/**===============================================================================
 * 	\) ===== Версии ===== (/
 *  
 *	0.1 - Релиз.
 *  0.2 - Добавлены настройки объекта.
=================================================================================*/

/**===============================================================================
	Инклуды
=================================================================================*/
#include <amxmodx>
#include <engine>

/**===============================================================================
	Данные
=================================================================================*/
#define MaxEntity 15
#pragma semicolon 1

/**===============================================================================
	Переменные
=================================================================================*/
new szFile[128], szEntity[MaxEntity+1][4][512], iLines;

/**===============================================================================
	Инициализация
=================================================================================*/
public plugin_init()
	register_clcmd("say /menuae", "ClCmdMenu");

/**===============================================================================
	Меню
=================================================================================*/
public ClCmdMenu(id)
{
	new menu = menu_create("\yЧто добавим ?", "menu_handler");
	new szItem[256], szIitem[4];
	menu_additem(menu, "Настройки объекта^n", "1");
	for(new i = 2; i <= iLines+1; i++)
	{
		num_to_str(i, szIitem, 3);
		format(szItem, charsmax(szItem), "%s", szEntity[i-1][2]);
		menu_additem(menu, szItem, szIitem);
	}
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL);
	menu_setprop(menu , MPROP_NEXTNAME, "Далее");
	menu_setprop(menu , MPROP_BACKNAME, "Назад");
	menu_setprop(menu , MPROP_EXITNAME, "Выход");
	menu_setprop(menu, MPROP_PERPAGE, 7);
	
	menu_display(id, menu, 0);
}

/**===============================================================================
	Игрок нажал пункт в меню
=================================================================================*/
public menu_handler(id, menu, item)
{
	if (item == MENU_EXIT)
	{
		menu_destroy(menu);

		return PLUGIN_HANDLED;
	}

	new s_Data[6], s_Name[64], i_Access, i_Callback;
	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback);
	new i_Key = str_to_num(s_Data);
	if(i_Key == 1)
	{
		ClCmdMenuSetting(id);
		return PLUGIN_HANDLED;
	}
	
	Add(id, szEntity[i_Key-1][1], str_to_num(szEntity[i_Key-1][3]));
	ClCmdMenu(id);
	
	return PLUGIN_HANDLED;
}

/**===============================================================================
	Меню настроек объекта
=================================================================================*/
public ClCmdMenuSetting(id)
{
	new menu = menu_create("\yНастройки объекта", "menu_handler_setting");
	menu_additem(menu, "Удалить^n", "1");
	menu_additem(menu, "Повернуть по \r--\yY", "2");
	menu_additem(menu, "Повернуть по \r++\yY^n", "3");
	menu_additem(menu, "Повернуть по \r--\yX", "4");
	menu_additem(menu, "Повернуть по \r++\yX^n", "5");
	menu_additem(menu, "Поднять", "6");
	menu_additem(menu, "Опустить^n", "7");

	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL);
	menu_setprop(menu , MPROP_NEXTNAME, "Далее");
	menu_setprop(menu , MPROP_BACKNAME, "Назад");
	menu_setprop(menu , MPROP_EXITNAME, "Выход");
	menu_setprop(menu, MPROP_PERPAGE, 7);
	
	menu_display(id, menu, 0);
}

/**===============================================================================
	Игрок нажал пункт в меню настроек
=================================================================================*/
public menu_handler_setting(id, menu, item)
{
	if (item == MENU_EXIT)
	{
		menu_destroy(menu);

		return PLUGIN_HANDLED;
	}

	new s_Data[6], s_Name[64], i_Access, i_Callback;
	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback);
	new i_Key = str_to_num(s_Data);
	new body, ent, classn[20];
	get_user_aiming(id, ent, body);
	entity_get_string(ent, EV_SZ_classname, classn, 19);
	if(!(is_valid_ent(ent) && equal(classn, "AddEntity")))
	{
		ClCmdMenuSetting(id);
		return PLUGIN_HANDLED;
	}
	new Float:fAngles[3], Float:fOrigin[3];
	entity_get_vector(ent, EV_VEC_angles, fAngles);
	entity_get_vector(ent, EV_VEC_origin, fOrigin);
	
	switch(i_Key)
	{
		case 1:
			remove_entity(ent);
		case 2:
		{
			fAngles[0]-=3.0;
			entity_set_vector(ent, EV_VEC_angles, fAngles);
		}
		case 3:
		{
			fAngles[0]+=3.0;
			entity_set_vector(ent, EV_VEC_angles, fAngles);
		}
		case 4:
		{
			fAngles[1]-=3.0;
			entity_set_vector(ent, EV_VEC_angles, fAngles);
		}
		case 5:
		{
			fAngles[1]+=3.0;
			entity_set_vector(ent, EV_VEC_angles, fAngles);
		}
		case 6:
		{
			fOrigin[2]+=5.0;
			entity_set_origin(ent, fOrigin);
		}
		case 7:
		{
			fOrigin[2]-=5.0;
			entity_set_origin(ent, fOrigin);
		}
	}

	ClCmdMenuSetting(id);
	
	return PLUGIN_HANDLED;
}

/**===============================================================================
	Загрузки плагина
=================================================================================*/
public plugin_precache()
{
	format(szFile, charsmax(szFile), "addons/amxmodx/configs/AddEntity.ini");
	new fHandle = fopen(szFile, "rt");
	
	if(!fHandle)
		return 0;
	
	new szBuffer[512], pos[4][256];
	while(!feof(fHandle))
	{
		fgets(fHandle, szBuffer, 511);
		if(szBuffer[0] == ';')
			continue;
		iLines++;
		parse(szBuffer, pos[1], 255, pos[2], 255, pos[3], 255);
		szEntity[iLines][1] = pos[1]; // Models
		szEntity[iLines][2] = pos[2]; // Name
		szEntity[iLines][3] = pos[3]; // Ups
		if(iLines >= MaxEntity)
			break;
	}
	fclose(fHandle);
	
	for(new i = 1; i <= iLines; i++)
		precache_model(szEntity[i][1]);
		
	return PLUGIN_CONTINUE;
}

/**===============================================================================
	Добавляем объект
=================================================================================*/
stock Add(id, const models[], ups)
{
	new iEnt, Float:fOrigin[3], iOrigin[3];
	get_user_origin(id, iOrigin, 3);
	IVecFVec(iOrigin, fOrigin);
	fOrigin[2] += float(ups);
	iEnt = create_entity("info_target");
	if(is_valid_ent(iEnt))
	{
		entity_set_float(iEnt, EV_FL_nextthink, get_gametime() + 0.1);
		entity_set_origin(iEnt, fOrigin);
		DispatchSpawn(iEnt);
		entity_set_model(iEnt, models);
		entity_set_string(iEnt, EV_SZ_classname, "AddEntity");
		entity_set_int(iEnt, EV_INT_solid, SOLID_BBOX);
		entity_set_size(iEnt, Float:{ -40.0, -40.0, -40.0 },  Float:{ 40.0, 40.0, 40.0 });
	}
}